//a rudimentary BankAccount, tracking a balance and interest rate
//Tested by class TestAccount in TestAccount.java.
//Make sure the CLASSPATH includes this (or current) directory--see README.TXT.)

class BankAccount
{ 
   double balance;        //current amount in this account
   double interestRate;  //interest accruing on this account
   
   public double interestRate()  //return current interestRate
   { return interestRate; }
   
   public void setRate(double newRate)
   { //precondition: newRate must be positive and not usurious
      if (newRate > 0.0 && newRate < 20.0)
         interestRate = newRate;
    }
   
    void deposit(double amount)  //add amount to account
    { //precondition: amount must be positive
      if (amount > 0.0)
        balance += amount;
    }
    
   void withdrawal(double amount)  //subtract amount from account
   { //preconditions: amount must be positive and no more than balance
      if (amount >= 0 && amount <= balance)
         balance -= amount;
   }
    
   double balance()     //return current balance
   { //round off balance to nearest cent
      int cents = (int)(balance *  100 + 0.5);
      return cents / 100.0;
   }
   
   void addInterest()    //tack on monthly interest
   { //1200.0 because we are accumulating interest percentage monthly
      balance += balance * (interestRate * 1200.0);
    }   
} //class BankAccount
