//Withdrawal manages a Withdrawal to any account

class Withdrawal extends Transaction
{ 
    Withdrawal(Account account) //get amount and add to account Withdrawals
    { boolean dispensed=false; //keep trying until money dispensed
       while (!dispensed)
       { System.out.print("Withdraw");
         super.askForAmount(); //Transaction's function
         //can only dispense money in $20 bills
          if ( (int) amount != amount || (int)(amount % 20) > 0)
                 System.out.println("Sorry, can only dispense money in $20 bills.");
          else if (!account.sufficientBalance(amount)) //enough to cover?
              System.out.println("Sorry, insufficient balance in your " + account.toString() + " account.");
         else try //subtract from balance, dispense & show new balance
            { account.subFromBalance(amount); //subtract from balance
               System.out.println("Dispensing $" + amount + " from " + account.toString());
               System.out.println("New balance in " + account.toString() + " is $"
	        + (account.getBalance() + account.getDeposits()));
               dispensed = true; //exit while loop
             }
            catch (ATMexception e)
            { System.out.println("withdrawal fails"); 
              e.printStackTrace(); 
            }//catch
       } //while
        
     //keep information about this transaction
     accountType = account.toString();
     balance = account.getBalance()+ account.getDeposits();
  } //Withdrawal constructor
     
  public String toString()
  { return "Withdrawal from " + accountType + " of $" + amount 
                  + " giving balance of $" + balance; 
  }
}
